/* 
   - The contents of this file are subject to the Mozilla Public
   - License Version 1.1 (the "License"); you may not use this file
   - except in compliance with the License. You may obtain a copy of
   - the License at http://www.mozilla.org/MPL/
   -
   - Software distributed under the License is distributed on an "AS
   - IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or
   - implied. See the License for the specific language governing
   - rights and limitations under the License.
   -
   - The Original Code is this file as it was released on
   - March 20, 2001.
   -
   - The Initial Developer of the Original Code is HJ van Rantwijk.
   - Portions created by HJ van Rantwijk are Copyright (C) 2001-2004
   - HJ van Rantwijk.  All Rights Reserved.
   -
   - Contributor(s):
   -  HJ van Rantwijk <bugs4hj@netscape.net> (Original Author)
   -  David Perry <d.perry@utoronto.ca> (limited to function preventDupeTab)
   -
*/

////////////////////////////////////////////////////////////////////////////////
function hideTab(aTab)
{
  var clsTab = "close";
  if (aTab.hasAttribute(clsTab))
    aTab.removeAttribute(clsTab);
  else aTab.setAttribute(clsTab, "true");
}
////////////////////////////////////////////////////////////////////////////////
function loadFirstTabPage(aTab)
{
  if (aTab == null)
   aTab = gBrowser.selectedTab;
  var mURI = aTab.getAttribute("firstPage");
  var aBrowser = gBrowser.getBrowserForTab(aTab);
  if (mURI != gBrowser.currentURI.spec && aBrowser)
    aBrowser.loadURI(mURI);
}
////////////////////////////////////////////////////////////////////////////////
function FillSelectedHistoryMenu(aParent, aMenu, aTab)
{
  var sessionHistory = getWebNavigation().sessionHistory;
  var end;
  var j;
  var entry;

  if (aTab) {
    var browser = gBrowser.getBrowserForTab(aTab);
    sessionHistory = browser.sessionHistory;
  }
  var count = sessionHistory.count;
  var index = sessionHistory.index;

  deleteHistoryItems(aParent);

  if (aMenu == "global" && count == 0)
    return;

  switch (aMenu)
    {
      case "go":
        aParent.lastChild.hidden = (count == 0);
        end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
        for (j = count - 1; j >= end; j--) {
          entry = sessionHistory.getEntryAtIndex(j, false);
          if (entry)
            createRadioMenuItem(aParent, j, entry.title, j==index);
        }
      break;

      case "tab":
        aParent.lastChild.hidden = (count > 0);
        end = count > MAX_HISTORY_MENU_ITEMS ? count - MAX_HISTORY_MENU_ITEMS : 0;
        for (j = count - 1; j >= end; j--) {
          entry = sessionHistory.getEntryAtIndex(j, false);
          if (entry)
            createRadioMenuItem(aParent, j, entry.title, j==index);
        }
      break;

      case "global":
        var history = document.getElementById("globalHistoryTree");
        var historyIndex = count = history.treeBoxObject.view.rowCount;
        aParent.childNodes[10].hidden = (count == 0);

        if (count > MAX_HISTORY_MENU_ITEMS)
          count = MAX_HISTORY_MENU_ITEMS;
        if (count == 0)
         return;

        var builder = history.builder.QueryInterface(Components.interfaces.nsIXULTreeBuilder);
        var nameResource = RDF.GetResource("http://home.netscape.com/NC-rdf#Name");

        for (j = count-1; j >= 0; j--) {
          var res = builder.getResourceAtIndex(j);
          var url = res.Value;
          var titleRes = history.database.GetTarget(res, nameResource, true);
          if (!titleRes)
            continue;

          var title = titleRes.QueryInterface(Components.interfaces.nsIRDFLiteral);
          createRadioMenuItem(aParent, (historyIndex-j), title.Value, (j+historyIndex)==index);
        }
      break;
    }
}
////////////////////////////////////////////////////////////////////////////////
function updateGoMenuPopup(aPopupMenu)
{
  var numberOfTabs = getBrowser().mTabContainer.childNodes.length;
  var disabled = (numberOfTabs == 1);
  var menuItems = aPopupMenu.getElementsByAttribute("tbattr", "tabbrowser-multiple");

  for (var i = 0; i < menuItems.length; i++)
    menuItems[i].setAttribute("disabled", disabled);
}
////////////////////////////////////////////////////////////////////////////////
function closeTabOrWindow() 
{
  var tabs = gBrowser.mTabContainer.childNodes.length;
  var lastTabBehavior = mzPreferences.readMyPref("multizilla.tabs.last-tab.close-window", "bool", false);
  var aboutBlank = (gBrowser.mCurrentBrowser.currentURI.spec == "about:blank");

  if (gBrowser.mTabbedMode) {
    if (tabs > 1)
      gBrowser.removeCurrentTab();
    else {
      if (lastTabBehavior && confirmCloseWS(1))
        BrowserCloseWindow();
      else 
        gBrowser.removeCurrentTab();
    }
  }
  else {
    if (confirmCloseWS(1))
      BrowserCloseWindow();
  }
}
////////////////////////////////////////////////////////////////////////////////
function preventDupeTab(aURL, useFirstPage, aBrowser, skipReload)
{
  if (mzPreferences.readMyPref("multizilla.prevent.double", "bool", true) && aURL.substring(0,10) != "javascript") {
    if (!aBrowser)
      aBrowser = getBrowser();
    var tabHref = null;
    var baseHref = aURL.replace(/#.*/, "");

    if (baseHref[baseHref.length-1] == '/')
      baseHref = baseHref.substring(0, baseHref.length-1);
    for (var i = 0; i < aBrowser.mTabContainer.childNodes.length; i++) {
      if (aBrowser.mTabContainer.childNodes[i].hasAttribute("busy") || useFirstPage)
        tabHref = aBrowser.mTabContainer.childNodes[i].getAttribute("firstPage");
      else { 
        /*** 
          * 'tabHref' is 'about:blank' when we're restoring a previously saved browser 
          * session, because we need to open new tabs first, before we can modify the 
          * DocShell properties for the corresponding browser!
          */
        // tabHref = aBrowser.mPanelContainer.childNodes[i].webNavigation.currentURI.spec;
        tabHref = aBrowser.getBrowserAtIndex(i).webNavigation.currentURI.spec;
      }
      tabHref = tabHref.replace(/#.*/, "");

      if (tabHref[tabHref.length-1] == '/')
        tabHref = tabHref.substring(0, tabHref.length-1);
      var tab = aBrowser.mTabContainer.childNodes[i];

      if (tab && baseHref == tabHref) {
        if (aBrowser.selectedTab != tab)
          aBrowser.selectedTab = tab;
        if (aURL.indexOf("#") != -1)
          loadURI(aURL); // anchor link like webpage.html#anchor
        else if (!skipReload)
          BrowserReloadWithFlags(Components.interfaces.nsIWebNavigation.LOAD_FLAGS_NONE);
        return tab;
      }
    }
  }
  return null;
}
////////////////////////////////////////////////////////////////////////////////
function checkForBlankTab(aBrowser)
{
  if (mzPreferences.readMyPref("multizilla.tabs.blank-tab-first", "bool", true)) {
    var page = "about:blank";
    aBrowser = aBrowser ? aBrowser : getBrowser();
    var numberOfTabs = aBrowser.mTabContainer.childNodes.length;

    for (var i = 0; i < numberOfTabs; i++) {
      if (aBrowser.mTabContainer.childNodes[i].hasAttribute("busy"))
        page = aBrowser.mTabContainer.childNodes[i].getAttribute("firstpage");
      else 
        // page = browser.mPanelContainer.childNodes[i].currentURI.spec
        page = aBrowser.getBrowserAtIndex(i).currentURI.spec

      if (page == "about:blank") {
        // return browser.mPanelContainer.childNodes[i];
        return aBrowser.getBrowserAtIndex(i);
      }
    }
  }
  return null;
}
////////////////////////////////////////////////////////////////////////////////
function openNewTabOrNewWindow()
{
  if (mzPreferences.readMyPref("multizilla.newtabfor.ctrl-n", "bool", true)) {
    var aTab = gBrowser.selectedTab = gBrowser.addPreferredTab();
    if (mzPreferences.readMyPref("browser.tabs.loadInBackground", "bool", true))
      getBrowser().selectedTab = aTab;
      setTimeout("gURLBar.focus();", 0);
  }
  else OpenBrowserWindow();
}
////////////////////////////////////////////////////////////////////////////////
function initMoveTabMenu(aID) 
{
  var windowManagerDS = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService(nsIWindowDataSource);
  var item = document.getElementById(aID);

  while ((item = item.nextSibling)) {
    var url = item.getAttribute('id');
    var win = windowManagerDS.getWindowForResource(url);
    if (win && win == window) {
      item.setAttribute("checked", "true");
      item.setAttribute("disabled", "true");
    }
    else if (!isNavigatorWindow())
      item.setAttribute("disabled", "true");
  }
}
////////////////////////////////////////////////////////////////////////////////
function moveTabToWindow(aTab, aWindowID, aRemoveTabFlag)
{
  var windowManagerDS = Components.classes['@mozilla.org/rdf/datasource;1?name=window-mediator'].getService(nsIWindowDataSource);
  var win = windowManagerDS.getWindowForResource(aWindowID);

  if (win && isNavigatorWindow()) {
    var aURL = gBrowser.getBrowserForTab(aTab).currentURI.spec;
    if (aURL) {
      var tabbrowser = win.getBrowser();
      // Add a new blank tab and use it as our targetTab
      var targetTab = tabbrowser.addTab(null, null, null, null, "duplicateTab");
      // 'tabbrowser.setReloadInterval()' fails without the next line!
      tabbrowser.selectedTab = targetTab;
      // Match first page attribute, used for menu item "Tab Home" (Shift+Home)
      targetTab.setAttribute("firstPage", aTab.getAttribute("firstPage"));
      // Check for a custom label on the source tab
      if (aTab.hasAttribute("customLabel"))
        tabbrowser.setCustomLabel(targetTab, aTab.getAttribute("label")); // Match that label
      // Match reload interval
      tabbrowser.setReloadInterval(targetTab, aTab.mReloadInterval);
      // Match docShell properties
      var sourceBrowser = gBrowser.getBrowserForTab(aTab);
      var targetBrowser = tabbrowser.getBrowserForTab(targetTab);
      tabbrowser.copyDocShellProperties(sourceBrowser, targetBrowser);
      // Match session history
      var tabHistory = gBrowser.getTabHistory(aTab);
      tabbrowser.setTabHistory(targetTab, tabHistory);
      // Select tab, based on the corresponding pref setting
      var loadInBackground = pref.getBoolPref("browser.tabs.loadInBackground");
      // Do we have to remove the source tab?
      if (aRemoveTabFlag)
        gBrowser.removeTab(aTab);
    }
  }
}
////////////////////////////////////////////////////////////////////////////////
function moveTabToNewWindow(aTab)
{
  var browser = gBrowser.getBrowserForTab(aTab);
  var aURL = browser.currentURI.spec;

  if (!browser || !aURL)
    return;
  else if (aURL == "about:blank" && browser.sessionHistory.count < 1) {
    var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
    promptService.alert(window, mzGetTextFromBundle("mzWizard"), mzGetTextFromBundle("moveBlankTab"));
    return;
  }
  else {
    var tabbrowser = openWindowAndReturnBrowser();
    // Select targetTab
    var targetTab = tabbrowser.mTabContainer.firstChild;
    // Match first page attribute, used for menu item "Tab Home" (Shift+Home)
    targetTab.setAttribute("firstPage", aTab.getAttribute("firstPage"));
    // Check for a custom label on the source tab
    if (aTab.hasAttribute("customLabel"))
      tabbrowser.setCustomLabel(targetTab, aTab.getAttribute("label")); // Match that label
    // Match reload interval
    tabbrowser.setReloadInterval(targetTab, aTab.mReloadInterval);
    // Match docShell properties
    tabbrowser.copyDocShellProperties(browser, tabbrowser);
    // Match session history
    var tabHistory = gBrowser.getTabHistory(aTab);
    tabbrowser.setTabHistory(targetTab, tabHistory);
    // It's a move so remove the source tab
    gBrowser.removeTab(aTab);
  }
}
////////////////////////////////////////////////////////////////////////////////
function doFKey(aFunctionKey)
{
  aFunctionKey--;
  if (aFunctionKey > -1 && aFunctionKey < gBrowser.mTabList.length)
    gBrowser.selectedTab = gBrowser.mTabList[aFunctionKey];
}
//////////////////////////////////////////////////////////////////////////
function addNewTabFromClipboard()
{
  var aURL = getLocationFromClipboard();
  if (aURL)
    gBrowser.selectedTab = gBrowser.addTab(aURL);
}
//////////////////////////////////////////////////////////////////////////
function advanceSelectedTab(aDirection)
{
  var startTab = gBrowser.mTabContainer.selectedItem;
  var startIndex = Number(startTab.ordinal);
  var tabs = gBrowser.mTabList;
  var nextIndex = startIndex + aDirection;
  var tab = null;

    if (nextIndex < 0 || nextIndex > gBrowser.mTabList.length-1)
      tab = (aDirection == -1) ? tabs[tabs.length-1] : tabs[0];
    else 
      tab = tabs[nextIndex];

    if (tab && tab != startTab)
      mzFocusTab(tab);
}
//////////////////////////////////////////////////////////////////////////
function mzFocusTab(aTab)
{
  // The following lines are copied from tabbox.xml to make it work with all Mozilla versions!
  var isTabFocused = (document.commandDispatcher.focusedElement == gBrowser.mTabContainer.selectedItem);
  gBrowser.mTabContainer.selectedItem = aTab;

  if (isTabFocused)
    aTab.focus();
  else if (gBrowser.mTabContainer.getAttribute("setfocus") != "false")
    document.commandDispatcher.advanceFocusIntoSubtree(aTab);
}
//////////////////////////////////////////////////////////////////////////
function doReload(aEvent, reloadAll)
{
  aEvent.preventBubble();
  if (aEvent.ctrlKey || reloadAll)
    gBrowser.reloadAllTabs(aEvent.shiftKey ? true : false);
  else if (aEvent.shiftKey)
    BrowserReloadSkipCache();
  else
    BrowserReload();
}
//////////////////////////////////////////////////////////////////////////
function doStop(aEvent, stopAll)
{
  aEvent.preventBubble();
  if (aEvent.ctrlKey || stopAll)
    gBrowser.stopAllTabs();
  else 
    BrowserStop();
}
//////////////////////////////////////////////////////////////////////////
// Mac users might need ctrl-left/ctrl right for back/forward in history
// Read pref for tab cycling behavior for Mac's to make them all happy
//////////////////////////////////////////////////////////////////////////
function doCtrlLeftRight(aDirection)
{
  var noTabCycling = false;

  if (/Mac/.test(navigator.platform)) {
    noTabCycling = mzPreferences.readMyPref("multizilla.mac-ctrl-left-right.behavior", "bool", false);
  }
  if (noTabCycling) {
    if (aDirection == -1)
      BrowserBack();
    else BrowserForward();
  }
  else {
    advanceSelectedTab(aDirection);
  }
}
//////////////////////////////////////////////////////////////////////////
function toggleTabBarVisibility()
{
  var tabBarDisplayed = gBrowser.getStripVisibility();
  var classname = tabBarDisplayed ? "mz-toolbar-hide-button" : "mz-toolbar-show-button";
  document.getElementById("tabstrip-tbbutton").setAttribute("class", classname);
  showHideTabbar();
  var switchTabBarMenuItem = document.getElementById("switchTabBarMenuItem");
  tabBarDisplayed = gBrowser.getStripVisibility();

  if (tabBarDisplayed)
    switchTabBarMenuItem.removeAttribute("disabled");
  else 
    switchTabBarMenuItem.setAttribute("disabled", "true");

  mzPreferences.writePref("bool", "browser.tabs.autoHide", !tabBarDisplayed);
}
////////////////////////////////////////////////////////////////////////////////
function getNumberOfBlankTabs(aTabBrowser)
{
  var blankTabs = 0;

  for (var i = 0; i < aTabBrowser.mPanelContainer.childNodes.length; i++) {
    var browser = aTabBrowser.getBrowserAtIndex(i);
    var tab = aTabBrowser.getTabForBrowser(browser);

    if (tab.hasAttribute("busy")) {
      if (tab.getAttribute("firstPage") == "about:blank")
        blankTabs++;
    }
    else if (browser.currentURI.spec == "about:blank")
      blankTabs++;
  }
  return blankTabs;
}
////////////////////////////////////////////////////////////////////////////////
function areAllTabsBlank(aTabBrowser)
{
  if (!aTabBrowser)
    aTabBrowser = getBrowser();

  var numberOfTabs = aTabBrowser.mTabContainer.childNodes.length;
  var numberOfBlankTabs = getNumberOfBlankTabs(aTabBrowser);
  return (numberOfTabs == numberOfBlankTabs) ? true : false;
}
////////////////////////////////////////////////////////////////////////////////
function handleNewTabLoadError(aBrowser, aLocation)
{
  // setTimeout(handleTabLoadError, 500, aBrowser, aLocation);
  handleTabLoadError(aBrowser, aLocation);
}
////////////////////////////////////////////////////////////////////////////////
function handleTabLoadError(aBrowser, aLocation)
{
  /* aURL = aLocation.replace(/\/$/, ""); // trim trailing /
  var firstPage = aBrowser.pendingTab.getAttribute("firstPage").replace(/\/$/, ""); // trim trailing /
  // dump("\nfirstPage: " + firstPage + "\naURL: " + aURL);

  if (firstPage != aURL) { // We need this check for 0x80450002 (load aborted) errors!
    aBrowser.pendingTab = null;
  }
  else { */
    var failureAction = 0;
    const failurePrefString = "multizilla.tabs.load-failure.behavior";

    failureAction = mzPreferences.readMyPref(failurePrefString, "int", 2);

    if (failureAction == 1) {
      gBrowser.removeTab(aBrowser.pendingTab);
      mzHideInBrowserHistory(aLocation);
      dump("\nWarning: tab closed, automatically, because it failed to load!");
    }
    else if (failureAction == 2)
    {
      var aEvent = window.document.createEvent('Events');
      aEvent.initEvent("DOMWillOpenModalDialog", false, false);
      aBrowser.contentDocument.defaultView.dispatchEvent(aEvent);

      var dialogTitle = "Load Error Detected...";
      var dialogQuestion = "The newly opened tab failed to load, do you want to close it?";
      var dialogCheckbox = {value:false};
      var dialogCheckboxText = "Remember my decision, don't ask again";
      var dialogRetryButton = "Retry";
      var promptService = Components.classes["@mozilla.org/embedcomp/prompt-service;1"].getService(Components.interfaces.nsIPromptService);
      var result = promptService.confirmEx(window, dialogTitle, dialogQuestion, promptService.BUTTON_POS_0_DEFAULT +
                                           (promptService.BUTTON_POS_0 * promptService.BUTTON_TITLE_IS_STRING) + 
                                           (promptService.BUTTON_POS_1 * promptService.BUTTON_TITLE_NO) +
                                           (promptService.BUTTON_POS_2 * promptService.BUTTON_TITLE_YES),
                                           dialogRetryButton, null, null, dialogCheckboxText, dialogCheckbox);

      aEvent.initEvent("DOMModalDialogClosed", false, false);
      aBrowser.contentDocument.defaultView.dispatchEvent(aEvent);

      if (result == 0) { // Retry/Reload
        aBrowser.pendingTab = null;
        aBrowser.loadURI(aLocation); // aURL);
      }
      else if (result == 1) // NO button selected (and ESC/X)
        aBrowser.pendingTab = null;
      else { // 2 = YES button selected (close tab)
        gBrowser.removeTab(aBrowser.pendingTab);
        mzHideInBrowserHistory(aLocation);
        dump("\nWarning: tab closed, after prompt, because it failed to load!");
      }
      if (dialogCheckbox.value)
        mzPreferences.writePref("int", failurePrefString, (!result));
    } // else if (failureAction == 2) {
  // } // else {
}
////////////////////////////////////////////////////////////////////////////////
function mzHideInBrowserHistory(aURI)
{
  return; 
  if (typeof(aURI) == "string") {
    const gIOService = Components.classes["@mozilla.org/network/io-service;1"].getService(Components.interfaces.nsIIOService);
    aURI = gIOService.newURI(aURI, null, null);
  }
  var globalHistory;
  // Builds 20040210 and up (see also mozilla bug 224829) 
  if ("@mozilla.org/browser/global-history;2" in Components.classes)
    globalHistory = Components.classes["@mozilla.org/browser/global-history;2"];
  else 
    globalHistory = Components.classes["@mozilla.org/browser/global-history;1"];

  globalHistory.getService(Components.interfaces.nsIBrowserHistory).hidePage(aURI);
}
////////////////////////////////////////////////////////////////////////////////
function mzOpenSearchInTab()
{
  if (mzPreferences.readMyPref("multizilla.newtabfor.websearch", "bool", true)) {
    var searchTab = gBrowser.addTab();

    // if (mzPreferences.readMyPref("browser.tabs.loadInBackground", "bool", false) == false)
      gBrowser.selectedTab = searchTab;
    return searchTab;
  }
  return null;
}
////////////////////////////////////////////////////////////////////////////////
function mzOpenSearch(aSearchStr)
{
  /* See also: http://lxr.mozilla.org/mozilla1.7/source/xpfe/browser/resources/content/navigator.js#999
     and:      http://lxr.mozilla.org/mozilla/source/xpfe/browser/resources/content/navigator.js#1034 */
  var newWindowFlag = (mzOpenSearchInTab() == null);
  var powerSearch;

  try {
    pref.getIntPref("browser.search.powermode");
    powerSearch = true;
  } catch(ex) {
    powerSearch = false;
  }
  if (powerSearch)
    OpenSearch('internet', false, aSearchStr, newWindowFlag);
  else 
    OpenSearch('internet', aSearchStr, newWindowFlag);
}